{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT Labels;

INTERFACE

USES
   Crt, Objects, MyMouse, Graph, Config;

TYPE
   PLabel = ^OLabel;
   OLabel = Object (TObject)
   Private
      Text      : String;
      oldWidth  : Integer;
      Change    : Boolean;
   Public
      Constructor Init(ix, iy: Integer; Tx : String; M : PMouse);
      Procedure   SetText(tx : String);
      Function    GetText : String;
      Procedure   Show; Virtual;
      Procedure   Draw; Virtual;
      Procedure   Run; Virtual;
      Destructor  Done;
   End;

IMPLEMENTATION

Constructor OLabel.Init(ix, iy: Integer; Tx : String; M : PMouse);

Begin
   TObject.Init(ix, iy, (Length(Tx)*8)+4, 10, M);
   Text     := Tx;
   oldWidth := 0;
   Change   := False;
End;

Procedure OLabel.SetText(tx : String);
Begin
   Text     := Tx;
   oldWidth := Width;
   Width    := (Length(Tx)*8)+4;
   Change   := True;
End;

Function OLabel.GetText : String;
Begin
   GetText := Text;
End;

Procedure OLabel.Draw;

Var
   ty : Integer;

Begin
   Pointer^.Show(False);
   if (Change) Then
   Begin
      SetColor(Backgr);
      For ty := y+1 To y+Height-1 Do
         Line(x+1, ty, x+oldWidth-1, ty);
   End;

   ty := y + (((y+Height - y) div 2) - 3);

   SetColor(TxColor);
   OutTextXY(x+2, ty, Text);
   Pointer^.Show(True);
End;

Procedure OLabel.Show;
Begin
   TObject.Show;
End;


Procedure OLabel.Run;
Begin
   If (Visible) Then Show;
End;

Destructor OLabel.Done;

Begin
   TObject.Done;
End;

End.
