{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT LowLevel;

INTERFACE

USES
   SysUtils,
   {$IFDEF MSWINDOWS}
   Windows,
   {$ENDIF}
   {$IFDEF LINUX}
   Types,
   Libc,
   {$ENDIF}
   SysConst,
   Msg;

TYPE
   { Hour and Date structure }

   Time = Record
      Hour  : Byte;
      Min   : Byte;
      Sec   : Byte;
      Day   : Byte;
      Month : Byte;
      Year  : Integer;
   End;

Procedure GetServerTime(Var Clock : Time);
Function GetStructTime(Mesg : Message) : Double;

IMPLEMENTATION


Procedure GetServerTime(Var Clock : Time);

Var
  DTime : TDateTime;
  STime : TSystemTime;

Begin
   DTime := Now;
   DateTimeToSystemTime(DTime, STime);
   Clock.Hour  := STime.wHour;
   Clock.Min   := STime.wMinute;
   Clock.Sec   := STime.wSecond;
   Clock.Day   := STime.wDay;
   Clock.Month := STime.wMonth;
   Clock.Year  := STime.wYear;
End;

Function GetStructTime(Mesg : Message) : Double;

Var
   Year  : Integer;
   Hour  : Integer;

Begin
   Year := Integer(Integer(Ord(Mesg[INF_YEARHI])) shl 8) or
                   Integer(Ord(Mesg[INF_YEARLO]));
   Hour := (Ord(Mesg[INF_HOUR])*60*60) +
           (Ord(Mesg[INF_MIN])*60) +
           (Ord(Mesg[INF_SEC]));
   GetStructTime := (Year*10000) +
                    (Ord(Mesg[INF_MONTH])*100) +
                    (Ord(Mesg[INF_DAY])) +
                    (Hour/10000);
End;


End.