{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

unit UMapObj;

INTERFACE

USES
   MyMouse, Graph, MapDB, ImgDB, Objects, Icones,
   Collects, MemIcons, UEleMap, Config, Devices;

CONST
   SPRITEWIDTH  = 16;
   SPRITEHEIGHT = 32;

TYPE
   PMapObj = ^OMapObj;
   OMapObj = Object (TObject)
      FName      : NameFSize;
      IName      : NameFSize;
      Map        : MapReg;
      MyMapDB    : PMapDB;
      Grid       : TGrid;
      ExistUser  : Boolean;

      Constructor Init(ix, iy : Integer; iFile: String; M : PMouse);
      Procedure   Construct; Virtual;
      Procedure   Run;  Virtual;
      Procedure   Show; Virtual;
      Procedure   Draw; Virtual;
      Procedure   SpriteToIcon(sprite : ImgSprite; ic :PIcon);
      Destructor  Done;
   End;


IMPLEMENTATION

Constructor OMapObj.Init(ix, iy : Integer; iFile: String; M : PMouse);

Begin
   TObject.Init(ix, iy, (MapWIDTH*SPRITEWIDTH)+2, (MapHEIGHT*SPRITEWIDTH)+SPRITEWIDTH, M);
   FName     := iFile;
   ExistUser := False;

   { Get MapObj from File }
   New(MyMapDB, Init(FName));
   MyMapDB^.Get(Map);
   Dispose(MyMapDB, Done);
   IName := Map.ImageFile;
End;

Procedure OMapObj.Construct;
Begin
End;

Procedure OMapObj.Draw;
Begin
End;

Procedure OMapObj.Show;
Begin
   TObject.Show;
End;

Procedure OMapObj.Run;
Begin
End;

Procedure  OMapObj.SpriteToIcon(sprite : ImgSprite; ic : PIcon);

Var
   i, j, l : Integer;

Begin
   l := 1;
   For j := 1 to SPRITEHEIGHT Do
      For i := 1 to SPRITEWIDTH Do
      Begin
         ic^.PutPixelColor(i, j, sprite[l]);
         inc(l);
      End;
End;

Destructor OMapObj.Done;

Var
  i, j : Integer;

Begin
   For j := 1 To MapHEIGHT Do
      For i := 1 To MapWIDTH Do
         If (Grid[i, j] <> Nil) Then Dispose(Grid[i, j], Done);
   TObject.Done;
End;

end.
