{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

{**********************************************

       File : videok7.pas
 Developper : Saulo Popov Zambiasi
Last Update : Feb/26/2002

    VIDEO K7, DVD, CABLE

**********************************************}

UNIT Videos;

INTERFACE

USES
   LowLevel, Msg, Agents, Devices, MapDB;

TYPE

   PVideo = ^OVideo;
   OVideo = Object (OAgent)
      TvOn      : Byte;
      TvLevel1  : Byte;
      TvLevel2  : Byte;
      TurnedOff : Boolean;
      FoundTV   : Boolean;
      Constructor Init(MS, AgType, Address : Byte; Dv : PDevice);
      Procedure   Run; Virtual;
      Procedure   Stop; Virtual;
      Destructor  Done;
   End;

IMPLEMENTATION

Constructor OVideo.Init(MS, AgType, Address : Byte; Dv : PDevice);
Begin
   OAgent.Init(MS, AgType, Address, Dv);
   WasOn     := False;
   TvOn      := 0;
   TvLevel1  := 0;
   TvLevel2  := 0;
   TurnedOff := False;
   FoundTV   := False;
End;

{**************************************************

   Run the opearations of Video Agent

**************************************************}

Procedure OVideo.Run;

Var
   Mesg : Message;

Begin
   OAgent.Run;
   TurnedOff := False;

   If (Not MesgLoaded) Then
   Begin
      GetBufferMesg(Mesg);

      { if not sleepy and if not lock }
      If ((Not Sleepy) and (lock = 0)) Then
      Begin
         If (Mesg <> 'NULL') Then
         Begin
            If ((Mesg[SENDER_TP] = Chr(UNIT_TV)) and
                (Mesg[MESG_TP] = 'I') and
                (Mesg[MESG_SUBTP] = 'S')) Then
            Begin
               TvOn     := Ord(Mesg[INF_ON]);
               TvLevel1 := Ord(Mesg[INF_LEVEL1]);
               TvLevel2 := Ord(Mesg[INF_LEVEL2]);
               MesgOut := MyID + Chr(Id[1]) + #58#255+'C'+#01#254#255#255#255;
               FoundTV := True;
               On := 1;
               WasOn := True;
               SetDevice;
               NextBufferMesg;
            End
            { If message is a voice command then execute}
            Else if (Mesg[MESG_TP] = 'C') Then
            Begin
               TurnedOff := ((On = 1) and (Ord(Mesg[CMD_ON]) = 0));
               If (Mesg[CMD_ON]     <> #255) Then On := Ord(Mesg[CMD_ON]);
               If (Mesg[CMD_LEVEL1] <> #255) Then On := Ord(Mesg[CMD_LEVEL1]);
               If (Mesg[CMD_LEVEL2] <> #255) Then On := Ord(Mesg[CMD_LEVEL2]);
               SetDevice;
               NextBufferMesg;
               MesgOut := MyId + Chr(Id[1]) + Chr(UNIT_TV) + #255 + 'RS';
               WasOn := Boolean(On);
            End
            { Else if message if anything else, then discard }
            Else NextBufferMesg;
         End;
      End;
   End;

   { if not sleepy and if not lock }
   If ((Not Sleepy) and (lock = 0)) Then
   Begin
      If (Presence <> Pres) Then
      Begin
         If (Presence) Then
         Begin
            If (WasOn) Then
               MesgOut := MyId + Chr(Id[1]) + Chr(UNIT_TV) + #255 + 'RS'
         End
         Else If (On = 1) Then
         Begin
            On    := 0;
            TurnedOff := True;
            SetDevice;
         End;
      End;
   End;

   If (TurnedOff) Then
   Begin
      If (FoundTV) Then
      Begin
         MesgOut := MyID + Chr(Id[1]) + Chr(UNIT_TV) + #255+ 'C' +
            Chr(TvOn) + Chr(TvLevel1) + Chr(TvLevel2) + #255#255;
      End;
      TurnedOff := False;
   End;

   Stop;
End;

{**************************************************

 Execute last functions to finich that moment task

***************************************************}

Procedure OVideo.Stop;
Begin
   OAgent.Stop;
End;

Destructor OVideo.Done;
Begin
   OAgent.Done;
End;

End.