{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT Objects;

INTERFACE

Uses
   MyMouse, Graph, Config;

TYPE
   PObject = ^TObject;
   TObject = Object
      X, Y      : Integer;
      Width     : Integer;
      Height    : Integer;
      Border    : Byte;
      Backoff   : Byte;
      Backon    : Byte;
      Backgr    : Byte;
      TxColor   : Byte;
      Pointer   : PMouse;
      MouseOver : Boolean;
      Align     : Alignation;
      Visible   : Boolean;
      Active    : Boolean;

      Constructor Init(ix, iy, w, h : Integer; M : PMouse);
      Procedure   Run;  Virtual;
      Procedure   Show; Virtual;
      Procedure   Draw; Virtual;
      Procedure   ClrScreen;
      Function    InRange : Boolean;
      Destructor  Done;
   End;

IMPLEMENTATION

Constructor TObject.Init(ix, iy, w, h : Integer; M : PMouse);
Begin
   X         := ix;
   Y         := iy;
   Width     := w;
   Height    := h;
   Pointer   := M;
   Border    := COLOR_BORDER;
   Backoff   := COLOR_BACKOFF;
   Backon    := COLOR_BACKON;
   Backgr    := COLOR_BACKGR;
   TxColor   := COLOR_TEXT;
   Align     := GENERAL_ALIGN;
   MouseOver := False;
   Visible   := True;
   Active    := True;
End;

Procedure TObject.Run;
Begin
End;

Procedure TObject.Draw;
Begin
End;

Function TObject.InRange : Boolean;

Var
   mx, my, mb : Integer;

Begin
   Pointer^.Status(mx, my, mb);
   InRange := (mx >= x) and (mx <= x+Width) and
              (my >= y) and (my <= y+Height);
End;

Procedure TObject.Show;

Begin
   If (InRange) Then
   Begin
      If (Not MouseOver) Then
      Begin
         Pointer^.Show(False);
         Draw;
         Pointer^.Show(True);
      End;
      MouseOver := True;
   End
   Else Begin
      If (MouseOver) Then
      Begin
         Pointer^.Show(False);
         Draw;
         Pointer^.Show(True);
      End;
      MouseOver := False;
   End;
End;

Destructor TObject.Done;
Begin
End;

Procedure TObject.ClrScreen;
Begin
   Pointer^.Show(False);
   SetBkColor(0);
   ClearDevice;
   Pointer^.Show(True);
End;

End.
